<template>
    <div>
        <div class="page-content">
            
            <!-- INNER PAGE BANNER -->
            <div class="wt-bnr-inr overlay-wraper bg-center" style="background-image:url(assets/images/banner/5.jpg);">
                <div class="overlay-main site-bg-secondry opacity-07"></div>
                <div class="container">
                    <div class="wt-bnr-inr-entry">
                        <div class="banner-title-outer">
                            <div class="banner-title-name">
                                <h2 class="site-text-primary" style="margin-top: 15%;">Projects</h2>
                            </div>
                        </div>
                        <!-- BREADCRUMB ROW -->                            
                        
                            <div>
                                <ul class="wt-breadcrumb breadcrumb-style-2">
                                    <li><a href="/">Home</a></li>
                                    <li>Projects</li>
                                </ul>
                            </div>
                        
                        <!-- BREADCRUMB ROW END -->                        
                    </div>
                </div>
            </div>
            <!-- INNER PAGE BANNER END -->
    
            <!-- GALLERY SECTION START -->
            <div class="section-full p-t80 p-b50 bg-white">
                <div class="container" >
                    
                    <div class="row d-flex justify-content-center">
                        <div class="col-xl-4 col-lg-4 col-md-12 col-sm-12 leftSidebar  m-b30">
                            <div class="theiaStickySidebar" style="padding-top: 0px; padding-bottom: 1px; position: static; transform: none; left: 964.6px; top: 0px;"><aside class="side-bar">
                                <!-- CATEGORY -->   
                                <div class="widget widget_services p-a20">
                                     <div class="text-left m-b30">
                                         <h3 class="widget-title">Installation Type</h3>
                                         
                                     </div>
                                     <ul>
                                        <li><a href="javascript:void(0);" @click.prevent="initPage()">All</a><span class="badge">28</span></li>
                                        <li><a href="javascript:void(0);" @click.prevent="doFilter('Commercial Rooftop')">Commercial Rooftop</a><span class="badge">14</span></li>
                                        <li><a href="javascript:void(0);" @click.prevent="doFilter('Residential Rooftop')">Residential Rooftop</a><span class="badge">12</span></li>
                                        <li><a href="javascript:void(0);" @click.prevent="doFilter('PLTS')">PLTS</a><span class="badge">01</span></li>
                                        <!-- <li><a href="javascript:void(0);">BTS</a><span class="badge">00</span></li>
                                        <li><a href="javascript:void(0);">PJUTS</a><span class="badge">00</span></li>  -->
                                                                                     
                                     </ul>
                                </div>                                               
                                                                          
                           
                            </aside></div>
                        </div>
                        <div class="col-xl-8 col-lg-8 col-md-12 col-sm-12 m-b30">
                            <!-- GALLERY CONTENT START -->
                            <div class="card" style="margin-bottom: 10px;">
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col-md-12 col-lg-12 col-sm-12">
                                            <h3 class="widget-title">Filter</h3>
                                        </div>
                                        <div class="col-lg-6 col-md-6 col-sm-12">
                                            <div class="form-group">
                                               <select id="filter-sorting" class="form-control" style="border: 1px solid;">
                                                   <option value="Newest">Sort By</option>
                                                   <option value="Newest">Newest - Oldest</option>
                                                   <option value="Oldest">Oldest - Newest</option>
                                               </select>
                                            </div>
                                        </div>
                                        <div class="col-lg-6 col-md-6 col-sm-12">
                                            <div class="form-group">
                                               <select id="filter-system-type" class="form-control"  style="border: 1px solid;">
                                                   <option value="" >System Type</option>
                                                   <option value="On-Grid">On-Grid</option>
                                                   <option value="Off-Grid">Off-Grid</option>
                                                   <option value="Hybrid">Hybrid</option>
                                               </select>
                                            </div>
                                        </div>
                                        <!-- <div class="col-lg-4 col-md-4 col-sm-4">
                                            <select id="filter-location" class="form-control"  style="border: 1px solid;">
                                                <option value="">Location</option>
                                                <option value="West Java">West Java</option>
                                                <option value="East Java">East Java</option>
                                                <option value="Central Jakarta">Central Jakarta</option>
                                                <option value="South Jakarta">South Jakarta</option>
                                                <option value="West Jakarta">West Jakarta</option>
                                                <option value="North Jakarta">North Jakarta</option>
                                                <option value="Bangka Belitung Island">Bangka Belitung</option>
                                                <option value="South Tangerang">South Tangerang</option>
                                                <option value="North Sulawesi">North Sulawesi</option>
                                                
                                            </select>
                                        </div> -->
                                    </div>
                                </div>
                            </div>
                            <div class="p-t40" style="height: 300px;" v-if="onLoad">
                                <div class="loader" >
                                    <span class="block-1"></span>
                                    <span class="block-2"></span>
                                    <span class="block-3"></span>
                                    <span class="block-4"></span>
                                    <span class="block-5"></span>
                                    <span class="block-6"></span>
                                    <span class="block-7"></span>
                                    <span class="block-8"></span>
                                    <span class="block-9"></span>
                                    <span class="block-10"></span>
                                    <span class="block-11"></span>
                                    <span class="block-12"></span>
                                    <span class="block-13"></span>
                                    <span class="block-14"></span>
                                    <span class="block-15"></span>
                                    <span class="block-16"></span>
                                </div>
                            </div>
                             <div class="row" v-if="!onLoad">
                                 <div class="col-lg-6 col-md-6 " v-for="prj in listProject">
                                     <div class="card" style="margin: 10px">
                                         <div class="card-body">
                                             <div class="blog-post date-style-2" >
                                                 <div class="wt-post-media wt-img-effect zoom-slow">
                                                     <a href="javascript:;" @click.prevent="$root.$router.push({name: 'project.detail', params: {slug: prj.slug}})"><img :src="'assets/images/'+prj.thumbnail" alt=""></a>
                                                 </div>
                                                 <div class="wt-post-info bg-white p-t30">
                                                     <div class="wt-post-meta ">
                                                         <ul>
                                                            <li class="post-date" style="font-size: 12pt;">{{prj.installation}} - {{prj.system_type}}</li>                                 
                                                         </ul>
                                                     </div>                                  
                                                 </div>
                                                 <div class="wt-post-title ">
                                                    <h3 class="post-title">
                                                        <a href="javascript:;" class="site-text-secondry" style="font-size: 12pt;">{{prj.name}}</a>
                                                    </h3>
                                                </div>
                                                 
                                                 <!-- <a href="assets/images/gallery/thumb/pic1.jpg" class="mfp-link"><i class="fa fa-search-plus"></i></a> -->
                                             </div>                                                    
                                         </div>
                                     </div>
                                 </div>
                                <!-- COLUMNS 1 -->
                                                                   
                             </div>
                             <div class="row  p-t30" v-if="!onLoad">
                                 <div class="col-md-12 col-lg-12 col-sm-12 justify-content-end">
                                    <ul class="pagination m-b0 p-b0 justify-content-end">
                                        <li class="page-item "><a class="page-link" href="javascript:void(0)" @click.prevent="prevPage()">Previous</a></li>
                                        <li v-for="p in pages" :class="curentPage == p ? 'page-item active': 'page-item'"><a class="page-link" href="javascript:void(0)" @click.prevent="changePage(p)">{{p}}</a></li>
                                        <li class="page-item"><a class="page-link" href="javascript:void(0)" @click.prevent="nextPage()">Next</a></li>
                                      </ul>
                                </div>
                             </div>
                            <!-- GALLERY CONTENT END --> 
                        </div>
                    </div>
                </div>
            </div>   
            <!-- GALLERY SECTION END --> 
        </div>
        <div style="position: relative; bottom: 0;background-color: #141c17;" >
            <div class="row">
                
                <div class="col-lg-12 col-md-12 col-sm-12"> 
                    <div > 
                        <div class="widget widget_about justify-content-center">
                        </div>
                        <div align="center" class="logo-footer justify-content-center">
                            <a href="index.html"><img src="/assets/images/logo.png" alt="" width="300"></a>
                        </div>
                        <ul align="center" class="social-icons  wt-social-links footer-social-icon p-b20 text-primary" style="font-size: 24pt; color: 03ad48;">
                            <li ><a style="margin-left: 5px; "  href="https://www.youtube.com/channel/UCGCwNBEAlSA6yFw5rLO-UXQ" target="_BLANK" class="fa fa-youtube-play text-primary"></a></li>
                            <li><a style="margin-left: 5px; color: 03ad48;" href="https://www.instagram.com/helixindo" target="_BLANK" class="fa fa-instagram  text-primary"></a></li>
                            <li><a style="margin-left: 5px; color: 03ad48;" href="https://www.facebook.com/helixindo" target="_BLANK" class="fa fa-facebook text-primary"></a></li>
                            <li><a style="margin-left: 5px; color: 03ad48;" href="https://www.linkedin.com/company/helixindo" target="_BLANK" class="fa fa-linkedin text-primary"></a></li>
                        </ul>
                        <ul align="center" class="footer-social-icon text-white">
                            <li>
                                <span align="center" class="copyrights-text">© 2020 <span class="site-text-primary">Helix Tenaga Surya. </span>All rights reserved. Powered by <span  ><a class="site-text-primary" href="https://visiprop.com" target="_BLANK">PT. Visiprop Technology Indonesia</a></span></span>
                            </li>
                        </ul>
    
                    </div>                              
                    
                </div> 
            </div>
        </div>
    </div>
    <!-- CONTENT START -->
    <!-- CONTENT END -->
</template>

<script>
    import { mapState } from 'vuex';

    export default {
        data() {
            return {
                curentPage: 1,
                pages: [1,2,3,4,5],
                listProject: [],
                filteredProject: [],
                storageProject: [],
                filteredBy: false,
                sortBy: 'Newest',
                filterSystem: '',
                filterLocation: '',
                onLoad: true
            }
        },
        beforeCreate() {
            document.title = 'Helixindo - Proyek'
        },
        computed: mapState(['project_en', 'project_id']),
        mounted() {
            $("html, body").animate({
				scrollTop: 0
			}, 500);
            this.initPage()
            $( "#filter-system-type" ).change((_val) => {
                console.log('cek')
                
                if(this.filterLocation != '') {   
                    this.resetFilter()
                    $( "#filter-location" ).val('').trigger('change')
                }
                this.filterSystem = $( "#filter-system-type" ).val()
                this.checkFilter()
            });
            $( "#filter-location" ).change((_val) => {
                if(this.filterSystem != '') {
                this.resetFilter()
                $( "#filter-system-type" ).val('').trigger('change')
                }
                this.filterLocation = $( "#filter-location" ).val()
                this.checkFilter()
            });
            $( "#filter-sorting" ).change((_val) => {
                this.resetFilter()
                this.sortBy = $( "#filter-sorting" ).val()
                this.checkFilter()
            });
        },
        methods: {
            resetFilter() {
                this.filteredBy = false
                this.sortBy = 'Newest'
                this.filterSystem = ''
                this.filterLocation = ''
            },
            initPage() {
                this.onLoad = true
                this.pages = []
                this.filteredProject = []
                this.filteredBy ? this.curentPage = 1 : false
                this.filteredBy = false
                this.storageProject = !localStorage.getItem('__LANG') || localStorage.getItem('__LANG') == 'en' ? 
                    this.project_en : this.project_id
                this.listProject = []
                if(this.storageProject.length > 0) {
                    this.checkSorting()
                }
                this.checkFilter()
                setTimeout(() => {
                    this.onLoad = false
                }, 2000)
            },
            checkSorting() {
                if(this.sortBy == 'Oldest') {
                    console.log('sini')
                    let temp = []
                    let index = this.storageProject.length - 1
                    while (index != -1) {
                        temp.push(this.storageProject[index])
                        index --
                    }
                    this.storageProject = temp
                }
            },
            changePage(page) {
                this.curentPage = page
                this.filteredBy ? this.initListFiltered() : this.initPage()
                // this.initPage()
            },
            prevPage() {
                if(this.curentPage != 1) {
                    this.curentPage --
                    this.filteredBy ? this.initListFiltered() : this.initPage()
                }
            },
            nextPage() {
                if(this.curentPage != 5) {
                    this.curentPage ++
                    this.filteredBy ? this.initListFiltered() : this.initPage()
                }
            },
            async doFilter(installaion) {
                this.onLoad = true
                this.pages = []
                this.filteredBy = true
                let temp
                this.listProject = []
                temp = []
                if(this.storageProject.length > 0) {
                    this.checkSorting()
                }
                await this.storageProject.map(_prj => {
                    if(_prj.installation == installaion) {
                        temp.push(_prj)
                    }
                })
                this.paginatorCreate(temp.length)
                this.filteredProject = temp
                this.initListFiltered()
                
                setTimeout(() => {
                    this.onLoad = false
                }, 2000)
                
            },
            async paginatorCreate(total) {
                let counter = 1
                if(total > 6) {
                    for (let index = 1; index < total+1; index++) {
                        if(index != 0 && (index % 6 == 0)) {
                            await this.pages.push(counter)
                            counter ++
                        }
                    }
                } 
                this.pages.push(counter)
            },
            checkFilter() {
                this.onLoad = true
                this.storageProject = !localStorage.getItem('__LANG') || localStorage.getItem('__LANG') == 'en' ? 
                    this.project_en : this.project_id
                let temp = []
                
                if(this.filteredBy) {
                    this.storageProject = this.filteredProject
                }
                if(this.filterLocation != '' && this.filterSystem != '') {
                    this.storageProject.map(_prj => {
                        if(_prj.location == this.filterLocation && _prj.system_type == this.filterSystem) {
                            temp.push(_prj)
                        }
                    })
                    this.storageProject = temp
                    this.fetchData()
                } else if(this.filterSystem != '') {
                    this.storageProject.map(_prj => {
                        if(_prj.system_type == this.filterSystem) {
                            temp.push(_prj)
                        }
                    })
                    this.storageProject = temp
                    this.fetchData()
                } else if(this.filterLocation != '' ) {
                    this.storageProject.map(_prj => {
                        if(_prj.location == this.filterLocation ) {
                            temp.push(_prj)
                        }
                    })
                    this.storageProject = temp
                    this.fetchData()
                } else {
                    this.fetchData()
                }
                
            },
            fetchData() {
                this.pages = []
                this.listProject = []
                if(this.storageProject.length > 0) {
                    this.checkSorting()
                }
                this.storageProject.map((_prj, index) => {
                    if(index < 6 ) {
                        if(this.curentPage == 1) {
                            _prj.page = 1,
                            this.listProject.push(_prj)
                        }
                    } else if (index > 5 && index < 12 ) {
                        if(this.curentPage == 2) {
                            _prj.page = 2,
                            this.listProject.push(_prj)
                        }
                    } else if (index > 11 && index < 18) {
                        if(this.curentPage == 3) {
                            _prj.page = 3,
                            this.listProject.push(_prj)
                        }
                    } else if (index > 17 && index < 24) {
                        if(this.curentPage == 4) {
                            _prj.page = 4,
                            this.listProject.push(_prj)
                        } 
                    } else if (index > 23 && index < 29) {
                        if(this.curentPage == 5) {
                            _prj.page = 5,
                            this.listProject.push(_prj)
                        }
                    }
                })
                this.paginatorCreate(this.storageProject.length)
                setTimeout(() => {
                    this.onLoad = false
                }, 2000)
            },
            initListFiltered() {
                this.listProject = []
                this.filteredProject.map((_prj, index) => {
                    if(index < 6 ) {
                        if(this.curentPage == 1) {
                            _prj.page = 1,
                            this.listProject.push(_prj)
                        }
                    } else if (index > 5 && index < 12 ) {
                        if(this.curentPage == 2) {
                            _prj.page = 2,
                            this.listProject.push(_prj)
                        }
                    } else if (index > 11 && index < 18) {
                        if(this.curentPage == 3) {
                            _prj.page = 3,
                            this.listProject.push(_prj)
                        }
                    } else if (index > 17 && index < 24) {
                        if(this.curentPage == 4) {
                            _prj.page = 4,
                            this.listProject.push(_prj)
                        } 
                    } else if (index > 23 && index < 29) {
                        if(this.curentPage == 5) {
                            _prj.page = 5,
                            this.listProject.push(_prj)
                        }
                    }
                })
            }
        }
    }
</script>